{$I-,Q-,R-,S-}
{Georgi Gerganov gr.Pleven}

const
  infile = '';
  outfile = '';

  maxn = 100;
  _A = 1;
  _E = 2;
  _O = 3;
  _K = 4;

type
  tr = record
    calc : boolean;
    br: int64;
  end;

var
  f : text;

  s, n, res : int64;

  r : array[1..maxn, _A.._K, -1..2] of tr;

procedure input;
begin
  assign(f, infile);
  reset(f);
  readln(f, s);
  close(f);
end;

function solve(nn, nb, ng : int64) : int64;
begin
  if r[nn, nb, ng].calc then solve:=r[nn, nb, ng].br
  else
  begin
    if nb=_A then
    begin
      r[nn, nb, 0].br:=0;
      r[nn, nb, 1].br:=solve(nn-1, _k, 0);
      r[nn, nb, 2].br:=solve(nn-1, _e, 1) + solve(nn-1, _o, 1);
    end;
    if nb=_O then
    begin
      r[nn, nb, 0].br:=0;
      r[nn, nb, 1].br:=solve(nn-1, _k, 0);
      r[nn, nb, 2].br:=solve(nn-1, _e, 1);
    end;
    if nb=_E then
    begin
      r[nn, nb, 0].br:=0;
      r[nn, nb, 1].br:=solve(nn-1, _k, 0);
      r[nn, nb, 2].br:=solve(nn-1, _o, 1);
    end;
    if nb=_K then
    begin
      r[nn, nb, 0].br:=solve(nn-1, _a, 1) + solve(nn-1, _a, 2) + solve(nn-1, _o, 1) + solve(nn-1, _o, 2) + solve(nn-1, _e, 1) + solve(nn-1, _e, 2);
      r[nn, nb, 1].br:=0;
      r[nn, nb, 2].br:=0;
    end;
    r[nn, nb, 0].calc:=true;
    r[nn, nb, 1].calc:=true;
    r[nn, nb, 2].calc:=true;
    solve:=r[nn,nb,ng].br;
  end;
end;

procedure output;
begin
  assign(f, outfile);
  rewrite(f);
  writeln(f, n);
  close(f);
end;

begin
  input;
  r[1, _a, 1].br:=1; r[1, _a, 1].calc:=true;
  r[1, _a, 0].br:=0; r[1, _a, 0].calc:=true;
  r[1, _a, 2].br:=0; r[1, _a, 2].calc:=true;
  r[1, _e, 1].br:=1; r[1, _e, 1].calc:=true;
  r[1, _e, 0].br:=0; r[1, _e, 0].calc:=true;
  r[1, _e, 2].br:=0; r[1, _e, 2].calc:=true;
  r[1, _o, 1].br:=1; r[1, _o, 1].calc:=true;
  r[1, _o, 0].br:=0; r[1, _o, 0].calc:=true;
  r[1, _o, 2].br:=0; r[1, _o, 2].calc:=true;
  r[1, _k, 0].br:=0; r[1, _k, 0].calc:=true;
  r[1, _k, 1].br:=0; r[1, _k, 1].calc:=true;
  r[1, _k, 2].br:=0; r[1, _k, 2].calc:=true;
  r[2, _a, 1].br:=1; r[2, _a, 1].calc:=true;
  r[2, _a, 0].br:=0; r[2, _a, 0].calc:=true;
  r[2, _a, 2].br:=2; r[2, _a, 2].calc:=true;
  r[2, _e, 1].br:=1; r[2, _e, 1].calc:=true;
  r[2, _e, 0].br:=0; r[2, _e, 0].calc:=true;
  r[2, _e, 2].br:=1; r[2, _e, 2].calc:=true;
  r[2, _o, 1].br:=1; r[2, _o, 1].calc:=true;
  r[2, _o, 0].br:=0; r[2, _o, 0].calc:=true;
  r[2, _o, 2].br:=1; r[2, _o, 2].calc:=true;
  r[2, _k, 0].br:=3; r[2, _k, 0].calc:=true;
  r[2, _k, 1].br:=0; r[2, _k, 1].calc:=true;
  r[2, _k, 2].br:=0; r[2, _k, 2].calc:=true;
  n:=1;
  res:=0;
  while true do
  begin
    res:=res+solve(n, _a, 1) + solve(n, _a, 2);
    res:=res+solve(n, _e, 1) + solve(n, _e, 2);
    res:=res+solve(n, _o, 1) + solve(n, _o, 2);
    res:=res+solve(n, _k, 0);
    //writeln(res);
    if res >= s then break;
    inc(n);
  end;
  output;
end.
