
/*
A3: ident
Vladimir Angelov
Pleven
*/

#include <iostream>
#include <cmath>

using namespace std;

typedef unsigned long ulong;

int check( int n, int b )
{
     int last = n % b;
     n /= b;
     
     while( n ) {
         int d = n % b;
         if( d != last )
             return 0;
             
         last = d;
         n /= b;
     }
     
     return 1;
}

int count( int n, int p )
{
    int d = 0;
    
    while( n ) {
        d++;
        n /= p;   
    }
        
    return d;
}     

int main()
{
    ulong n, p, k = 2;
    
    cin >> n >> p;
    
    while( 1 ) {
        if( check( n * k, p ) ) {
           cout << count( n * k, p ) << " " << ( n * k )%10 << "\n";
           return 0;
        }
        
        if( n * k > 100000000 ) 
            break;
        
        k++;
    }

    cout << "0\n";

	return 0;
}
