/* Petar Ivelinov Ivanov, Shumen, A */

#include <stdio.h>

const int MAX_N = 100000 +5;

int n, m;

int A[MAX_N];
int V[MAX_N];

void input ()
{
   int i;

   scanf ("%d%d", &n, &m);

   for (i=1; i<=n; i++)
      scanf ("%d", &A[i]);
}

void erase ()
{
   int i;

   for (i=0; i<=n; i++)
      V[i] = -1;
}

void dfs (int p)
{
   if (V[p] == -1) V[p] = 1;
   else {
      printf ("%d\n", p);
      return;
   }
   
   if (p == 0) return;

   dfs (A[p]);
}

void solve ()
{
   int i;
   int a, b;

   for (i=1; i<=m; i++) {
      scanf ("%d%d", &a, &b);
      erase ();
      dfs (a);
      dfs (b);
   }
}

int main ()
{
   input ();
   solve ();

   return 0;
}
