#include <stdio.h>
#define MAX 1000005
#define INF 123456789

long used[MAX], max;

int main(void)
{
    long n, m;
    long ans, a, cnt, best;
    long i;
    
    /* get input */
    scanf("%ld %ld", &n, &m); 
    
    /* init used */
    for(i = 0; i < n; i++) used[i] = 0; max = 0;
    
    /* solve */
    best = INF; ans = 0;
    for(i = 1; i < m; i++) {
      a = 0; max++; cnt = 0;
      for( ; ; ) {
        cnt++;
        a = (a * m + i) % n;
        if(used[a] == max) break;
        used[a] = max;
        if(!a) break;
      }
      if(!a && cnt < best) { ans = i; best = cnt; }
    }
    
    /* print solution */
    if(!ans) printf("%ld\n", ans);
    else printf("%ld %ld\n", best, ans);
    
    return 0;
}
      
    
    
