#include <stdio.h>
#include <stdlib.h>

int main(void)
{
    int N, i, j, temp;
    unsigned long a[30000], sum;
    
    printf("Enter the number of numbers: ");
    scanf("%d", &N);
    if ((N<3)||(N>30000)){
      printf("The number must be in the range 3-30000\n");
      exit(1);
    }
    
    for(i=0; i<N; i++){
      printf("Enter number #%d: ", i+1);
      scanf("%d", &a[i]);
      if(a[i]<1){
        printf("The number cannot be smaller than 1\n");
        exit(1);
      }
      sum += a[i];
    }
    
    temp = sum%3;
         
    if(!temp){
      printf("Answer: 0");
      exit(0);
    }
    
    for(i=0; i<N; i++)
      if((a[i]%3)==temp){
        printf("Answer: 1");
        exit(0);
      }
      
    for(i=0; i<(N-1); i++)
      for(j=i+1; j<N; j++)
        if(((a[i]+a[j])%3)==temp){
          printf("Answer: 2");
          exit(0);
        }
    
    return 0;
}
