program MEET;

type TTown = record
      H:LongInt;
      OutTown:LongInt;
      InTown1,InTown2:LongInt;
     end;

var Towns:array of TTown;
    N:LongInt;
    M:Byte;

procedure WeightTree(const ATown,Height:LongInt);
begin
 with Towns[ATown] do begin
  H := Height;
  If not(InTown1 = - 1) then WeightTree(InTown1,Height + 1);
  If not(InTown2 = - 1) then WeightTree(InTown2,Height + 1);
 end;
end;

function GetIntersect(A,B:LongInt):LongInt;
begin
 while not(A = B) do begin

  If (Towns[A].H = Towns[B].H) then begin
   A := Towns[A].OutTown;
   B := Towns[B].OutTown;
  end;

  If (Towns[A].H > Towns[B].H) then A := Towns[A].OutTown;
  If (Towns[B].H > Towns[A].H) then B := Towns[B].OutTown;

 end;
 GetIntersect := A;
end;

procedure Input;
var iTown,J,X,Y:LongInt;
    iQuest:Byte;
begin
 Readln(N,M);
 SetLength(Towns,N + 1);

 for iTown := 0 to N do begin
  Towns[iTown].InTown1 := - 1;
  Towns[iTown].InTown2 := - 1;
 end;

 for iTown := 1 to N do begin
  Readln(J);
  Towns[iTown].OutTown := J;

  If (Towns[J].InTown1 = - 1) then Towns[J].InTown1 := iTown
  else Towns[J].InTown2 := iTown;
 end;

 WeightTree(0,0);

 for iQuest := 1 to M do begin
  Readln(X,Y);
  Writeln(GetIntersect(X,Y));
 end;

end;


begin
 Input;
 Finalize(Towns);
end.