/* Veselin Krasimirov Kulev */

#include <stdio.h>
#include <limits.h>
#include <string.h>
#include <time.h>

using namespace std;

#define IN "ident.in"
#define OUT "ident.out"

#define MAXN (1<<20)
#define MOD(b) ((b)%(A))
#define MIN(a,b) (((a<b))?(a):(b))

int A,P;

char vis[MAXN];

int solve (int k) {
	memset(vis,0,sizeof(vis));
    vis[0] = 1;
    int len = 1;
    int d = k;
    int step = P;

    while (vis[d] == 0) {
    	vis[d] = 1;
    	len++;
        d = MOD( d + k * step );
        step = MOD(step * P);
    }

    if (d == 0) return len;
    else return INT_MAX;
}

int main () {
    scanf("%d%d",&A,&P);

    if (A == 1) {
    	printf("1 1\n");
        return 0;
    }

    int bestlen = INT_MAX;
    int bestans = 0;

    for (int i=1; i<P; i++) {
    	int t = solve(i);
        if (t < bestlen) {
        	bestlen = t;
            bestans = i;
        }
    }

    if (bestlen == INT_MAX) {
    	printf("0\n");
    } else {
    	printf("%d %d\n",bestlen,bestans);
    }

    return 0;
}
