program meet;

const
	MAXN						= 100002;
	LOGN						= 19;
	MAXD						= 2 * MAXN;

type
	Integer						= LongInt;
	TEdge						= record
		t, n					: Integer;
	end;
	TRMQ						= record
		v, i					: Integer;
	end;

var
	d						: Array [1 .. MAXD, 1 .. LOGN] of TRMQ;
	pow2						: Array [0 .. LOGN] of Integer;
	g						: Array [1 .. MAXN * 2] of TEdge;
	used						: Array [1 .. MAXN] of Boolean;
	ind, lev					: Array [1 .. MAXN * 2] of Integer;
	first						: Array [1 .. MAXN] of Integer;
	level						: Array [1 .. MAXN] of Integer;
	head						: Array [1 .. MAXN] of Integer;
	n, m, i, j, x, y, gn, clev, cn, x1		: Integer;

procedure addedge(x, y: Integer);
begin
	gn := gn + 1;
	g[gn].t := y; g[gn].n := head[x]; head[x] := gn;
	gn := gn + 1;
	g[gn].t := x; g[gn].n := head[y]; head[y] := gn;
end;

procedure dfs(c: Integer);
var
	i						: Integer;
begin
	used[c] := True;
	clev := clev + 1;
	level[c] := clev;
	i := head[c];
	cn := cn + 1;
	ind[cn] := c;
	while (i > 0) do begin
		if (not used[g[i].t]) then begin
			dfs(g[i].t);
			cn := cn + 1;
			ind[cn] := c;
		end;
		i := g[i].n;
	end;
	clev := clev - 1;
end;

procedure swap(var a, b: Integer);
var
	t						: Integer;
begin
	t := a; a := b; b := t;
end;

begin
	readln(n, m);
	for i := 1 to n+1 do head[i] := 0;
	gn := 0;
	for i := 1 to n do begin
		readln(j);
		addedge(i+1, j+1);
	end;
	n := n + 1;
	for i := 1 to n do used[i] := False;
	clev := 0;
	cn := 0;
	dfs(1);
	for i := 1 to cn do lev[i] := level[ind[i]];
	pow2[0] := 1;
	for i := 1 to logn do pow2[i] := 2 * pow2[i-1];
	for i := 1 to cn do begin
		d[i, 1].v := lev[i];
		d[i, 1].i := i;
	end;
	for j := 2 to logn do
		for i := 1 to cn do
			if (i + pow2[j-2] - 1 >= cn) then
				d[i, j] := d[i, j-1]
			else begin
                        	if (d[i, j-1].v < d[i+pow2[j-2], j-1].v) then
                                	d[i, j] := d[i, j-1]
                                else
                                	d[i, j] := d[i+pow2[j-2], j-1];
                        end;
	for i := 1 to n do first[i] := -1;
	for i := 1 to cn do
		if (first[ind[i]] = -1) then first[ind[i]] := i;
	for i := 1 to m do begin
		readln(x, y);
		x := x + 1; y := y + 1;
		x := first[x]; y := first[y];
		if (x > y) then swap(x, y);
		j := 0;
		while (pow2[j] <= y-x+1) do j := j + 1;
		j := j - 1;
		if (d[x, j+1].v < d[y-pow2[j]+1, j+1].v) then
			x1 := d[x, j+1].i
		else
			x1 := d[y-pow2[j]+1, j+1].i;
		writeln(ind[x1]-1);
	end;
	
end.