{$I-,Q-,R-,S-}
const
   MAX_N = 100100;
   MAX_M = 110;
type
   tnode = record
      l, r : longint;
   end;
   tnode2 = record
      l1, l2, r1, r2, v : longint;
   end;
   txy = record
      x, y : longint;
   end;

var
   m, n : longint;
   a : array[0..MAX_N] of tnode;
   b : array[0..MAX_M] of txy;
   c : array[1..MAX_N] of tnode2;
   ind : array[0..MAX_N] of longint;
   cnt : longint;

function dfs(i : longint) : longint;
var ll, rr, t : longint;
begin
   inc(cnt);
   t:=cnt;
   c[t].v:=i;
   ind[i]:=t;
   ll:=0; rr:=0;
   if a[i].l <> 0 then
      ll:=dfs(a[i].l);
   if a[i].r <> 0 then
      rr:=dfs(a[i].r);
   c[t].l1:=t+1;
   c[t].l2:=t+ll;
   c[t].r1:=t+ll+1;
   c[t].r2:=t+ll+rr;
   dfs:=ll+rr+1;
end;

procedure swap(var a, b : longint);
var t : longint;
begin
   t:=a;
   a:=b;
   b:=t;
end;

function query(x, y : longint) : longint;
var xi, yi, i : longint;
begin
   xi:=ind[x];
   yi:=ind[y];

   if xi > yi then swap(xi, yi);

   i:=1;
   while true do
   begin
      if (i = xi) or (i = yi) then
         break;

      if {(c[i].l1 <= xi) and} (xi <= c[i].l2) then
      begin
         if (c[i].r1 <= yi) {and (yi <= c[i].r2)} then
            break
         else
            i:=c[i].l1;
      end
      else
         i:=c[i].r1;
   end;

   query:=c[i].v;
end;

var
{   fin : text;}
   i, j : longint;
begin
{   assign(fin, 'meet.in');
   reset(fin);}
   readln({fin,} n, m);
   for i:=1 to n do
   begin
      readln({fin,} j);
      if a[j].l = 0 then
         a[j].l:=i
      else
         a[j].r:=i;
   end;
   for i:=1 to m do
      readln({fin,} b[i].x, b[i].y);
{   close(fin);}

   dfs(0);

   for i:=1 to m do
      writeln(query(b[i].x, b[i].y));
end.