/*
TASK: MEET
LANG: C++
*/
// by Svilen Marchev

#include <stdio.h>
//#include <conio.h>
#include <set>
#include <algorithm>
using namespace std;

#define MAXN    100010

struct req {
	int a,b,c;
	req(){}
	req(int a1,int a2,int a3):a(a1),b(a2),c(a3){}
	bool operator<(const req& x) const {
		if (a == x.a) return (b<x.b);
		return (a<x.a);
	}
};
set<req> r;

int prev[MAXN+1], lev[MAXN+1];
int n, m;

int dfs(int i)
{
	if (lev[i]==0) lev[i] = dfs(prev[i]) + 1;
	return lev[i];
}

int main()
{
	//freopen("meet.in","r",stdin);  // TO REM
	scanf("%d%d",&n,&m);
	int i,x,y,x1,y1;
	for (i = 1; i <= n; ++i) {
		scanf("%d",&x);
		prev[i] = x;
	}
	prev[0] = -1;
	for (i = 1; i <= n; ++i) lev[i] = 0;
	lev[0] = 1;
	
	for (i = 1; i <= n; ++i) if (lev[i]==0) dfs(i);
	//for (i = 0; i <= n; ++i) printf("%d,", prev[i]);
	
	set<req>::iterator it;
	for (i = 0; i < m; ++i) {
		scanf("%d%d",&x1,&y1);
		x = min(x1,y1);
		y = max(x1,y1);
		x1=x; y1=y;

		if ((it = r.find(req(x,y,0))) != r.end()) {
			printf("%d\n",(int)(*it).c);
			continue;
		}
		
		while (lev[y] > lev[x]) y = prev[y];
		while (lev[x] > lev[y]) x = prev[x];
		while (x != y) {
            y = prev[y];
            x = prev[x];
		}
		printf("%d\n",x);
		r.insert(req(x1,y1,x));
	}
	
	return 0;
}
