// proj1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


class Point
{
	float x;
	float y;
public:

	Point(float x_,float y_)
		:
	
		x(x_),y(y_)
		{}

		float get_x()
		{
			return x;
		}

		float get_y()
		{
			return y;
		}



};


class List
{
	struct Link
	{
	Point obj;
	Link* suc;
	Link* pre;
	Link(Point& obj_)
		:
	
		obj(obj_),suc(NULL),pre(NULL)
		{}
	};

	Link* head;

public:

	List()
		
	{
		Point p(0,0);
    	head=new Link(p); 

	
		Link* pom=new Link(p);
		pom->pre=head;
		head->suc=pom;
	}


	Link* end()
	{
		Link* pom=head;
		while(pom->suc)
		{
			pom=pom->suc;
		}

		return pom;
	}


	void push(float x,float y)
	{
		Point p(x,y);
		Link* pom=new Link(p);
		Link* back=end()->pre;

		pom->suc=end();
		pom->pre=end()->pre;
		end()->pre=pom;
		back->suc=pom;
	}

	
	bool compare(Point p)
	{
		Link* pom=head;
		while(pom!=end())
		{
			if(double(pom->obj.get_x())==double(p.get_x()) && double(pom->obj.get_y())==double(p.get_y()))
				return true;

			pom=pom->suc;
		}
		return false;
	}
	
};

class Triangle
{
	Point a;
	Point b;
	Point c;

	List mab;
	List mbc;
	List mac;

public:

	Triangle(float xa,float ya,float xb,float yb,float xc,float yc)
		:
	a(xa,ya),b(xb,yb),c(xc,yc)
	{}


	void synchronize()
	{
		float p=get_min(a.get_x(),b.get_x());
		double ab_step=abs(get_max(get_height_ab(),get_weight_ab())/get_min(get_height_ab(),get_weight_ab()));
		ab_step/=10;
		float x=get_min(a.get_x(),b.get_x());
		float y=get_min(a.get_y(),b.get_y());

		float ch=(get_max(a.get_x(),b.get_x()));
		int br=0;

		while(br!=get_weight_ab()*10)
		{
			mab.push(x+=0.1,y+=ab_step);
			p+=0.1;
			br++;

		}

        p=get_min(b.get_x(),c.get_x());
		double bc_step=abs(get_max(get_height_bc(),get_weight_bc())/get_min(get_height_bc(),get_weight_bc()));
		bc_step/=10;
		x=get_min(b.get_x(),c.get_x());
		y=get_min(b.get_y(),c.get_y());
		br=0;

		while(br!=get_weight_bc()*10 )
		{
			mbc.push(x+=0.1,y+=bc_step);
			p+=0.1;
			br++;

		}


		p=get_min(a.get_x(),c.get_x());
		double ac_step=abs(get_max(get_height_ac(),get_weight_ac())/get_min(get_height_ac(),get_weight_ac()));
		ac_step/=10;
		x=get_min(a.get_x(),c.get_x());
		y=get_min(a.get_y(),c.get_y());
		br=0;

		while(br!=get_weight_ac()*10)
		{
			mac.push(x+=0.1,y+=ac_step);
			p+=0.1;
			br++;

		}



	}



	List* close_x(float cl)
	{
		if( abs(cl-a.get_x()) < abs(cl-b.get_x()) )
			if( abs(cl-b.get_x()) < abs(cl-c.get_x()) )
				return &mab;
			else
				return &mac;
			else
				if( abs(cl-a.get_x()) < abs(cl-b.get_x()) )
				return &mac;

				else
				return &mbc;


	}



				
			

	float get_max(float a_, float b_)
	{
		return a_>b_?a_:b_;
	}


	float get_min(float a_, float b_)
	{
		return a_<=b_?a_:b_;
	}


	float get_weight_ab()
	{
		return abs(a.get_x()-b.get_x());
	}

	float get_height_ab()
	{
		return abs(a.get_y()-b.get_y());
	}


	float get_len_ab()
	{
		return sqrt (pow(a.get_x()-b.get_x(),2) + pow(a.get_y()-b.get_y(),2) );
	}
	

	float get_weight_bc()
	{
		return abs(b.get_x()-c.get_x());
	}

	float get_height_bc()
	{
		return abs(b.get_y()-c.get_y());
	}


	float get_len_bc()
	{
		return sqrt (pow(b.get_x()-c.get_x(),2) + pow(b.get_y()-c.get_y(),2) );
	}


	float get_weight_ac()
	{
		return abs(a.get_x()-c.get_x());
	}

	float get_height_ac()
	{
		return abs(a.get_y()-c.get_y());
	}

	float get_len_ac()
	{
		return sqrt (pow(a.get_x()-c.get_x(),2) + pow(a.get_y()-c.get_y(),2) );
	}

};

class Line
{
	Point t1;
	Point t2;

public:
	Line(float xt1,float yt1,float xt2,float yt2)
		:
	t1(xt1,yt1),t2(xt2,yt2)
	{}


	Point& get_t1()
	{
		return t1;
	}


	Point& get_t2()
	{
		return t2;
	}


	float get_len()
	{
		return sqrt(pow(t1.get_x()-t2.get_x(),2) + pow(t1.get_y()-t2.get_y(),2));
	}


};

float intersec(Triangle& t,Line& l)
{
    List* list=t.close_x(l.get_t1().get_x());
	float step=0;

	float _t1=l.get_t1().get_x()-l.get_t2().get_x();
	if(l.get_t1().get_y()-l.get_t2().get_y()!=0)
	step=abs( abs(l.get_t1().get_x()-l.get_t2().get_x() ) /abs (l.get_t1().get_y()-l.get_t2().get_y()));
	step/=100;
	float x=l.get_t1().get_x();
	float y=l.get_t1().get_y();
	bool start=false;
	float len=0;


	while(x<99999)
	{
		Point p(x+=0.1,y-=step);
		if(list->compare(p))
		{
			start=true;
		}
		if(start)
		{
			len+=0.1;
		}
	}


	x=l.get_t1().get_x();
	start=false;
	while(x<99999)
	{
		Point p(x-=step,y+=step);
		
		if(list->compare(p))
		{
			start=true;
		}
		if(start)
		{
			len+=0.001;
		}
	}
	return len;

}

int main(int argc, char* argv[])
{
	int ax,ay,bx,by,cx,cy,mx,my,nx,ny;
    cin>>ax>>ay>>bx>>by>>cx>>cy>>mx>>my>>nx>>ny;

	Triangle t(ax,ay,bx,by,cx,cy);
	t.synchronize();
	Line l(mx,my,nx,ny);
	cout<<intersec(t,l);
	getch();
	return 0;
}

