#include <cstdio>

typedef signed int ind;
typedef long long unsigned int counter;

const char *read_ind = "%d";
const char *write_ind = "%d";
const char *read_counter = "%llu";
const char *write_counter = "%llu";

enum ending {AK, EA, EO, EK, OA, OE, OK, KA, KE, KO};
const ind endings = 10;

int main()
{
	counter old[endings], nu[endings];

	counter maxsum;
	std::scanf(read_counter, &maxsum);

	for (ind i = 0; i < endings; i++)
		old[i] = 1;

	counter sum = 3;
	ind ans = 2;
	for (; sum < maxsum; ans++)
	{
		counter s = 0;
		for (ind i = 0; i < endings; i++)
			s += old[i];

		sum += s;

		for (ind i = 0; i < endings; i++)
			nu[i] = 0;

		nu[KA] += old[AK];
		nu[KE] += old[AK];
		nu[KO] += old[AK];
		nu[AK] += old[EA];
		nu[OK] += old[EO];
		nu[KA] += old[EK];
		nu[KE] += old[EK];
		nu[KO] += old[EK];
		nu[AK] += old[OA];
		nu[EK] += old[OE];
		nu[KA] += old[OK];
		nu[KE] += old[OK];
		nu[KO] += old[OK];
		nu[AK] += old[KA];
		nu[EA] += old[KE];
		nu[EO] += old[KE];
		nu[EK] += old[KE];
		nu[OA] += old[KO];
		nu[OE] += old[KO];
		nu[OK] += old[KO];

		for (ind i = 0; i < endings; i++)
			old[i] = nu[i];
	}

	std::printf(write_ind, ans-1);
	std::printf("\n");

	return 0;
}
