#include <stdio.h>
#include <queue>
#define maxn 100010
#define maxm 110

using namespace std;

struct t1
{ long to,next;
};

t1 data[maxn];
long begin[maxn],c=1,n,m,d2[2][maxm],lev[maxn],pred[maxn];

queue<long> q1;
void swap(long *a,long *b)
{ long c=*a;
  *a=*b;
  *b=c;
}
void inp(void)
{ long i,j;
  scanf("%ld%ld",&n,&m);
  n++;
  for (i=1;i<n;i++)
  { scanf("%ld",&j);
    data[c].to=i;
	data[c].next=begin[j];
	begin[j]=c++;
  }
  for(i=0;i<m;i++) scanf("%ld%ld",&d2[0][i],&d2[1][i]);
}
void bfs(void)
{ long x,p;
  q1.push(0);
  lev[0]=0;
  while (!q1.empty())
  { x=q1.front();
    p=begin[x];
	while(p)
	{ q1.push(data[p].to);
	  lev[data[p].to]=lev[x]+1;
	  pred[data[p].to]=x;
	  p=data[p].next;
	}
	q1.pop();
  }
}
long find(long a,long b)
{ long i;
  if (lev[a]>lev[b]) swap(&a,&b);
  while (lev[b]>lev[a]) b=pred[b];
  while (a!=b)
  { a=pred[a];
    b=pred[b];
  }
  return a;
}
void work(void)
{ long i,j;
  for (i=0;i<m;i++) printf("%ld\n",find(d2[0][i],d2[1][i]));
}
int main(void)
{ memset(begin,0,sizeof(begin));
  data[0].to=data[0].next=0;
  inp();
  bfs();
  work();
  return 0;
}
