    #include <iostream>
    #include <cmath>
    using namespace std;

    long Ax,Ay, Bx,By, Cx,Cy, Nx,Ny, Mx, My;
    
    void read_inp()
    {
         cin>>Ax; cin>>Ay;
         cin>>Bx; cin>>By;
         cin>>Cx; cin>>Cy;
         
         cin>>Mx; cin>>My;
         cin>>Nx; cin>>Ny;
    }
    
    long D(int x1, int y1, int x2, int y2, int x3, int y3)
    {
         return ( x1*(y2-y3) - y1*(x2-x3) + (x2*y3 - y2*x3) );
    }
    
    bool intersect(int x1, int y1, int x2, int y2, int xp, int yp, int xq, int yq)
    {
        if( D(x1,y1, x2,y2, xp,yp) != D(x1,y1, x2,y2, xq,yq) &&
            D(xp,yp, xq,yq, x1,y1) != D(xp,yp, xq,yq, x2,y2) ) return 1;
        else return 0;
    }
    
    double distance(long x1, long y1, long x2, long y2)
    {
           long dx=abs(x2-x1);
           long dy=abs(y2-y1);
           return sqrt( (dx*dx + dy*dy) );
    }
    
    int main()
    {
         read_inp();
         int posM, posN;    // pos=1 - outside triangle
                            // pos=2 - element of a side of the triangle
                            // pos=3 - inside triangle
         if(( D(Ax,Ay, Bx,By, Mx,My)==0 ||
              D(Bx,By, Cx,Cy, Mx,My)==0 ||
              D(Cx,Cy, Ax,Ay, Mx,My)==0) ) posM=2;      //M leji na nqkoq stena
         else if(( D(Ax,Ay, Bx,By, Mx,My)<0 &&
                   D(Bx,By, Cx,Cy, Mx,My)<0 &&
                   D(Cx,Cy, Ax,Ay, Mx,My)<0) ||
              
                 ( D(Ax,Ay, Bx,By, Mx,My)>0 &&
                   D(Bx,By, Cx,Cy, Mx,My)>0 &&
                   D(Cx,Cy, Ax,Ay, Mx,My)>0) ) posM=3;   //M e v ABC
              else posM=1;
         
         if(( D(Ax,Ay, Bx,By, Nx,Ny)==0 ||
              D(Bx,By, Cx,Cy, Nx,Ny)==0 ||
              D(Cx,Cy, Ax,Ay, Nx,Ny)==0) ) posN=2;     //N leji na nqkoq strana
         else if(( D(Ax,Ay, Bx,By, Nx,Ny)<0 &&
                   D(Bx,By, Cx,Cy, Nx,Ny)<0 &&
                   D(Cx,Cy, Ax,Ay, Nx,Ny)<0) ||
              
                 ( D(Ax,Ay, Bx,By, Nx,Ny)>0 &&
                   D(Bx,By, Cx,Cy, Nx,Ny)>0 &&
                   D(Cx,Cy, Ax,Ay, Nx,Ny)>0) ) posN=3;    //N e v ABC
              else posN=1;
         
         //otse4kata leji na/v ABC
         if( (posN==2 || posN==3) && (posM==2 || posN==3) ) cout<<distance(Mx,My, Nx,Ny)<<endl;
         else if( posN==1 && posM==1)                //M,N ne sa v ABC
              {
                  if(     intersect(Ax,Ay, Bx,By, Mx,My, Nx,Ny)==0 ||
                          intersect(Bx,By, Cx,Cy, Mx,My, Nx,Ny)==0 ||
                          intersect(Cx,Cy, Ax,Ay, Mx,My, Nx,Ny)==0  ) cout<<"0.000"<<endl;
                          //MN nqma ob6ti to4ki s ABC
                
             //sega da vidim koi si spomnq uravnenie na prava...
             //MN e bila prava??!?!? @ 13:50
         }
//         system("pause");
    }
